/*
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * If you have not received a copy of the GNU General Public License, see <http://www.gnu.org/licenses/>.
 */


var yesScriptBrowserOverlay = {
	sites: [],
	get button() {
		return document.getElementById("yesscript-button");
	},
	init: function() {
		Components.utils.import("resource://gre/modules/Services.jsm");  
		gBrowser.addProgressListener(yesScriptBrowserOverlay);
		gBrowser.tabContainer.addEventListener("TabSelect", yesScriptBrowserOverlay.updateStatus, false);
		yesScriptCommon.updateCallbacks.push(yesScriptBrowserOverlay.updateStatus);
		yesScriptBrowserOverlay.updateStatus();
		yesScriptBrowserOverlay.installButton("nav-bar", "yesscript-button", "search-container"); 	
	},
	installButton: function(toolbarId, id, afterId) {
		var checkfirstRun;
		try  {checkfirstRun = Services.prefs.getBoolPref("extensions.scriptblock.firstRun");} catch(e) {checkfirstRun=true;}
		if (checkfirstRun) 
		{	if (!document.getElementById(id)) 
			{	var toolbar = document.getElementById(toolbarId);
				var before = null;
				if (afterId) 
				{	let elem = document.getElementById(afterId);
					if (elem && elem.parentNode == toolbar) before = elem.nextElementSibling;
				}
				toolbar.insertItem(id, before);
				toolbar.setAttribute("currentset", toolbar.currentSet);
				document.persist(toolbar.id, "currentset");
			}
			try  {Services.prefs.setBoolPref("extensions.scriptblock.firstRun", false);} catch(e) {}
		} 
	},
	QueryInterface: function(aIID) {
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
		    aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
		    aIID.equals(Components.interfaces.nsISupports))
			return this;
		throw Components.results.NS_NOINTERFACE; 
	},
	onLocationChange: function(progress, request, uri) {
		if (uri && uri.spec == yesScriptBrowserOverlay.currentURI.spec) {
			yesScriptBrowserOverlay.updateStatus();
		}
	},
	onStateChange: function() {},
	onProgressChange: function() {},
	onStatusChange: function() {},
	onSecurityChange: function() {},
	onLinkIconAvailable: function() {},
	updateStatus: function() {
		var blacklisted = yesScriptCommon.isBlacklisted(yesScriptBrowserOverlay.currentURI.spec) != null;
		var key = blacklisted ? "blacklisted" : "notBlacklisted";
		if (yesScriptBrowserOverlay.button) {
			yesScriptBrowserOverlay.button.setAttribute("tooltiptext", yesScriptCommon.strings.getFormattedString(key, [yesScriptCommon.getSiteString(yesScriptBrowserOverlay.currentURI.spec)]));
			yesScriptBrowserOverlay.button.setAttribute("blacklisted", blacklisted);
		}
	},
	toggle: function() {
		if (yesScriptBrowserOverlay.button) {
			yesScriptCommon.blacklist(yesScriptBrowserOverlay.currentURI.spec, !(yesScriptBrowserOverlay.button.getAttribute("blacklisted") == "true"));
		}
	},
	get currentURI() {
		return gBrowser.currentURI;
	}
}
window.addEventListener("load", function load(event){
  window.removeEventListener("load", load, false); yesScriptBrowserOverlay.init();},false);
